From 87604929c53cc30496ac838696823889d88f14c1 Mon Sep 17 00:00:00 2001
From: bill-auger <mr.j.spam.me@gmail.com>
Date: Feb 25 2023 00:28:03 +0000
Subject: [PATCH 19/33] [udev]: WIP - upgrade to v252.5


---

diff --git a/nonsystemd/udev/PKGBUILD b/nonsystemd/udev/PKGBUILD
index 97b7330..17d4874 100644
--- a/nonsystemd/udev/PKGBUILD
+++ b/nonsystemd/udev/PKGBUILD
@@ -9,33 +9,39 @@ _pkgbase=systemd-stable
 pkgbase=udev
 pkgname=('udev' 'libudev' 'esysusers' 'etmpfiles')
 pkgdesc='Userspace device file manager'
-_tag='95d0353dad616c275fda9b123ba9660e16b20d0a' # git rev-parse v${_tag_name}
-_tag_name=250.2
+_tag='b16ce4c7ab80665b65345ea030c51a5c758fe66b' # git rev-parse v${_tag_name}
+_tag_name=252.5
 pkgver="${_tag_name/-/}"
 pkgrel=1
 arch=('x86_64')
 arch+=('i686' 'armv7h')
 url='https://www.github.com/systemd/systemd'
 license=('GPL2' 'LGPL2.1')
-makedepends=('acl' 'libacl.so' 'kmod' 'libkmod.so' 'util-linux' 'libblkid.so'
-             'hwdata' 'libcap' 'libcap.so' 'kbd' 'gperf' 'intltool' 'git'
-             'meson' 'docbook-xsl' 'rsync' 'python-jinja')
+makedepends=('acl' 'kmod' 'util-linux' 'hwdata' 'libcap' 'kbd' 'gperf'
+            'intltool' 'git' 'meson' 'docbook-xsl' 'rsync' 'python-jinja')
 options=('strip')
 validpgpkeys=('63CDA1E5D3FC22B998D20DD6327F26951A015CC4'  # Lennart Poettering <lennart@poettering.net>
               'A9EA9081724FFAE0484C35A1A81CEA22BC8C7E2E'  # Luca Boccassi <luca.boccassi@gmail.com>
+              '9A774DB5DB996C154EBBFBFDA0099A18E29326E1'  # Yu Watanabe <watanabe.yu+github@gmail.com>
               '5C251B5FC54EB2F80F407AAAC54CA336CFEB557E') # Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl>
-_commit=29cd296aa4635fe6f7b53bda2f2cb1648bdc0782
-source=("git+https://github.com/systemd/systemd-stable#tag=${_tag}?signed"
-        "git+https://github.com/systemd/systemd#tag=v${_tag_name%.*}?signed"
+_alpm=57bcc7fee22d75df96fd546ee7215166cdfb1233
+source=("git+https://github.com/systemd/systemd-stable#tag=${_tag}" #?signed
+        "git+https://github.com/systemd/systemd#tag=v${_tag_name%.*}" #?signed
         '0001-Use-Arch-Linux-device-access-groups.patch'
         initcpio-{hook,install}-udev
-        git+https://gitea.artixlinux.org/artix/alpm-hooks.git#commit=$_commit)
+        "git+https://gitea.artixlinux.org/artix/alpm-hooks.git#commit=${_alpm}"
+        meson-install-tags.patch
+        meson-artix.patch
+        udev-log-msg.patch)
 sha512sums=('SKIP'
             'SKIP'
-            '10f3b477527ec263cc6465c84d94416e356435930edc9e26844a0fd4f71e87a27fa0f91ce24b43a22cacdd2ead5e760e9d607369bc537a8da8d34021302a89a1'
+            'f26db75129f1f9a7b7235d77e4ec490864fa0a203431f515873443b227da3db7034d8d81f7974f23fc6fbeaa91727244ac8ab82762f02e87fb92ea19a6bd931f'
             '32606b42856b5f3ea7f485143e532671f58986237e14c58ea5ab17383dc39a375cb6c738c8a2db9e4a8c8be88ea44a876d6bbed129cb2f5c9aa3f8228b04d927'
             '38eed28d42ac8f70bc8d1058ace35f137f7f5c972442ee14b98c2146202e0615aa584304edbd59e8608d1b6bec3cb391fc69b25393740f6eabd8fc5ad3bde64f'
-            'SKIP')
+            'SKIP'
+            'e936a4b245400140d2cb4ed250fe23639bc3aaf81fb958b9b10dc1ff5aeb094f37b657e044bf35e832fd4a69dccea5b19ef45d20852ce3aa49325ae2e59d8f51'
+            'a26003ddcac5a83ec1fec040b36ff46816869028dc79aebb2646f9f2ed090e6358601f911c9d6a04b426c7f3367595e12716e411fca34ffce59d718b067e4e5c'
+            '268817ee63ca0b03d2a10bb952837052c1fa80a5d2f0fe933d2aa3d61a09d286f188a6358107114964930fcef7057392f9520f875a83f6e265d2f4bc2564c26e')
 
 _backports=(
 )
@@ -58,149 +64,213 @@ prepare() {
         git log --oneline -1 "${_c}"
         git revert -n "${_c}"
     done
+    patch -Np1 -i ../meson-install-tags.patch
+    patch -Np1 -i ../meson-artix.patch
+    patch -Np1 -i ../udev-log-msg.patch
 
     # Replace cdrom/dialout/tape groups with optical/uucp/storage
     patch -Np1 -i ../0001-Use-Arch-Linux-device-access-groups.patch
 }
 
-_get_libudev() {
-    echo "$(readlink build/libudev.so.1)"
-}
-
-_inst_bin() {
-    local bin="$1"
-
-    install -Dm755 build/systemd-"$bin".standalone "${pkgdir}"/usr/bin/"$bin"
-    install -d "${pkgdir}"/usr/lib/"$bin".d
-
-    install -d "${pkgdir}"/usr/share/{doc/"${pkgname}",man/man{5,8}}
-
-    install -m644 build/man/"$bin".d.5 "${pkgdir}"/usr/share/man/man5/
-    install -m644 build/man/systemd-"$bin".8 "${pkgdir}"/usr/share/man/man8/"$bin".8
-
-    install -m644 "$_pkgbase"/LICENSE.* "${pkgdir}"/usr/share/doc/"${pkgname}"
-}
-
 build() {
     local _meson_options=()
 
     _meson_options+=(
         -Dversion-tag="${_tag_name/-/\~}-${pkgrel}-parabola"
+        -Dshared-lib-tag="${pkgver}-${pkgrel}"
         -Dmode=release
 
         -Dstandalone-binaries=true
         -Dsysusers=true
         -Dtmpfiles=true
-
-        -Dadm-group=true
-        -Dwheel-group=true
-        -Dgshadow=true
         -Dhwdb=true
         -Dblkid=true
+        -Dgshadow=true
+
+        -Dinstall-sysconfdir-standalone=true
+        -Ddefault-udevd-symlink='udevd'
+        -Ddefault-udevd-dir='/usr/bin'
+
+        -Dsbat-distro='artix'
+        -Dsbat-distro-summary='Artix Linux'
+        -Dsbat-distro-pkgname="${pkgname}"
+        -Dsbat-distro-version="${pkgver}"
 
+        -Dtests=true
+
+        -Dlink-udev-shared=false
+        -Dlink-boot-shared=false
         -Dman=false
-        -Dtests=false
 
         -Ddns-servers=''
         -Dntp-servers=''
         -Defi=false
 
-        -Dlink-udev-shared=false
-
-        -Dlibidn2=false
-        -Dlibidn=false
-        -Dlibcryptsetup=false
-        -Didn=false
+        -Dsysvinit-path=
+        -Ddefault-dnssec=no
+
+        -Dadm-group=false
+        -Danalyze=false
+        -Dapparmor=false
+        -Daudit=false
+        -Dbacklight=false
+        -Dbinfmt=false
+        -Dbzip2=false
+        -Dcoredump=false
+        -Ddbus=false
+        -Delfutils=false
+        -Denvironment-d=false
+        -Dfdisk=false
         -Dgcrypt=false
+        -Dglib=false
+        -Dgnutls=false
+        -Dhibernate=false
+        -Dhostnamed=false
+        -Didn=false
+        -Dima=false
+        -Dinitrd=false
+        -Dfirstboot=false
+        -Dkernel-install=false
+        -Dldconfig=false
+        -Dlibcryptsetup=false
+        -Dlibcurl=false
+        -Dlibfido2=false
+        -Dlibidn=false
+        -Dlibidn2=false
         -Dlibiptc=false
+        -Dlocaled=false
+        -Dlogind=false
         -Dlz4=false
+        -Dmachined=false
+        -Dmicrohttpd=false
+        -Dnetworkd=false
+        -Dnscd=false
+        -Dnss-myhostname=false
+        -Dnss-resolve=false
+        -Dnss-systemd=false
+        -Doomd=false
+        -Dopenssl=false
         -Dp11kit=false
+        -Dpam=false
+        -Dpcre2=false
+        -Dpolkit=false
+        -Dportabled=false
+        -Dpstore=false
+        -Dpwquality=false
+        -Drandomseed=false
+        -Dresolve=false
+        -Drfkill=false
         -Dseccomp=false
-        -Dxz=false
-
-        -Dtimesyncd=false
-        -Dnss-systemd=false
-        -Dnss-resolve=false
-        -Dnss-mymachines=false
-        -Dnss-myhostname=false
-        -Dnetworkd=false
-        -Dmachined=false
+        -Dsmack=false
+        -Dsysext=false
         -Dtimedated=false
-        -Dkernel-install=false
-        -Dresolve=false
+        -Dtimesyncd=false
+        -Dtpm=false
+        -Dqrencode=false
+        -Dquotacheck=false
+        -Duserdb=false
+        -Dutmp=false
+        -Dvconsole=false
+        -Dwheel-group=false
         -Dxdg-autostart=false
+        -Dxkbcommon=false
+        -Dxz=false
+        -Dzlib=false
+        -Dzstd=false
     )
+    artix-meson "$_pkgbase" build "${_meson_options[@]}"
 
-    arch-meson "$_pkgbase" build "${_meson_options[@]}"
-
-    local _udev=() _man=() _ebin=()
-
-    _udev+=(
-        $(_get_libudev)
+    local _targets=()
+    _targets+=(
+        udev:shared_library
         src/libudev/libudev.pc
         udevadm
+        systemd-hwdb
         src/udev/{ata_id,cdrom_id,fido_id,mtd_probe,dmi_memory_id,scsi_id,v4l_id}
         src/udev/udev.pc
-        rules.d/{50-udev-default.rules,64-btrfs.rules}
+        rules.d/{50-udev-default,64-btrfs}.rules
         hwdb.d/60-autosuspend-chromiumos.hwdb
-    )
+        man/{libudev.3,udev.conf.5,hwdb.7,udev.7,udevadm.8}
 
-    _ebin+=(
         systemd-{sysusers,tmpfiles}.standalone
         sysusers.d/basic.conf
         tmpfiles.d/{etc,static-nodes-permissions,var}.conf
-    )
-
-    _man+=(
         man/{sysusers,tmpfiles}.d.5
         man/systemd-{sysusers,tmpfiles}.8
-        man/{libudev.3,udev.conf.5,hwdb.7,udev.7,udevadm.8}
+        factory/templates/locale.conf
+
+        systemd-detect-virt
+        test/sys
+        test-udev
+        test-fido-id-desc
+        test-udev-builtin
+        test-udev-event
+        test-udev-node
+        test-udev-util
+        systemd-runtest.env
+        test-tmpfiles
     )
+    meson compile -C build "${_targets[@]}"
+}
 
-    ninja -C build "${_udev[@]}" "${_ebin[@]}" "${_man[@]}"
+check() {
+    local tests=()
+    tests+=(
+        test-sysusers.standalone
+        test-systemd-tmpfiles.standalone
+        test-tmpfiles
+        rule-syntax-check
+        test-fido-id-desc
+        test-udev-builtin
+        test-udev-event
+        test-udev-node
+        test-udev-util
+#         udev-test
+        test-libudev
+        test-libudev-sym
+        test-udev-device-thread
+    )
+    meson test -C build --print-errorlogs "${tests[@]}"
+}
+
+_inst_doc(){
+    install -d "${pkgdir}"/usr/share/doc/"${pkgname}"
+    install -vm644 "$_pkgbase"/LICENSE.* "${pkgdir}"/usr/share/doc/"${pkgname}"
+}
+
+_inst_man_udev() {
+    local x="$1" y=${1##*.}
+    install -d "${pkgdir}"/usr/share/man/man"$y"
+    install -vm644 build/man/"$x" "${pkgdir}"/usr/share/man/man"$y"
+}
+
+_inst_man_utils() {
+    local u="$1"
+    install -d "${pkgdir}"/usr/share/man/man{5,8}
+    install -vm644 build/man/"$u".d.5 "${pkgdir}"/usr/share/man/man5
+    install -vm644 build/man/systemd-"$u".8 "${pkgdir}"/usr/share/man/man8/"$u".8
 }
 
 package_udev() {
     pkgdesc='Userspace device file manager'
     depends=('acl' 'libacl.so' 'kmod' 'libkmod.so'
             'util-linux' 'libblkid.so' 'libudev' 'hwdata' 'kbd')
-    provides=("udev=$pkgver" 'eudev')
+    provides=("udev=$pkgver")
+    provides+=('eudev')
     replaces=('eudev')
 
-    install -d "${pkgdir}"/etc/udev/{hwdb,rules}.d
-    mv -v "$_pkgbase"/src/udev/udev.conf "${pkgdir}"/etc/udev
-
-    install -d "${pkgdir}"/usr/bin
-    mv -v build/udevadm "${pkgdir}"/usr/bin/udevadm
-    ln -sfv udevadm "${pkgdir}"/usr/bin/udevd
+    meson install -C build --destdir "$pkgdir" --no-rebuild --tags udev,udev-devel,libudev-devel
 
-    install -d "${pkgdir}"/usr/{share,lib}/pkgconfig
-    mv -v build/src/libudev/libudev.pc "${pkgdir}"/usr/lib/pkgconfig
-    mv -v build/src/udev/udev.pc "${pkgdir}"/usr/share/pkgconfig
+    mv -v  "${pkgdir}"/usr/bin/systemd-hwdb "${pkgdir}"/usr/bin/udev-hwdb
 
-    install -d "${pkgdir}"/usr/lib/udev
-    mv -v build/src/udev/{*_id,mtd_probe} "${pkgdir}"/usr/lib/udev
-
-    mv -v build/hwdb.d "${pkgdir}"/usr/lib/udev/
-    mv -v "$_pkgbase"/hwdb.d/{*.hwdb,README} "${pkgdir}"/usr/lib/udev/hwdb.d/
-    mv -v build/rules.d "${pkgdir}"/usr/lib/udev/
-    mv -v "$_pkgbase"/rules.d/{*.rules,README} "${pkgdir}"/usr/lib/udev/rules.d/
-
-    install -d "${pkgdir}"/usr/include
-    mv -v "$_pkgbase"/src/libudev/libudev.h "${pkgdir}"/usr/include
-
-    install -d "${pkgdir}"/usr/share/man/man{3,5,7,8}
-    mv -v build/man/libudev.3 "${pkgdir}"/usr/share/man/man3/
-    mv -v build/man/udev.conf.5 "${pkgdir}"/usr/share/man/man5/
-    mv -v build/man/udev.7 "${pkgdir}"/usr/share/man/man7/
-    mv -v build/man/udevadm.8 "${pkgdir}"/usr/share/man/man8/
-
-    install -d "${pkgdir}"/usr/share/doc/"${pkgname}"
-    install -m644 "$_pkgbase"/LICENSE.* "${pkgdir}"/usr/share/doc/"${pkgname}"
+    for m in libudev.3 udev.conf.5 udev.7 udevadm.8; do
+        _inst_man_udev "$m"
+    done
+    _inst_doc
 
     # initcpio
-    install -D -m0644 initcpio-install-udev "${pkgdir}"/usr/lib/initcpio/install/udev
-    install -D -m0644 initcpio-hook-udev "${pkgdir}"/usr/lib/initcpio/hooks/udev
+    install -vD -m0644 initcpio-install-udev "${pkgdir}"/usr/lib/initcpio/install/udev
+    install -vD -m0644 initcpio-hook-udev "${pkgdir}"/usr/lib/initcpio/hooks/udev
 
     # pacman hooks
     make -C alpm-hooks DESTDIR="${pkgdir}" install_udev
@@ -209,11 +279,11 @@ package_udev() {
 package_libudev() {
     pkgdesc='udev library for enumerating and introspecting local devices'
     depends=('gcc-libs')
-    provides=('libudev.so' 'libeudev')
+    provides=('libudev.so')
+    provides+=(''libeudev')
     replaces=('libeudev')
 
-    install -d "${pkgdir}"/usr/lib
-    mv -v build/{libudev.so{,.1},$(_get_libudev)} "${pkgdir}"/usr/lib/
+    meson install -C build --destdir "$pkgdir" --no-rebuild --tags libudev
 }
 
 package_esysusers() {
@@ -221,10 +291,12 @@ package_esysusers() {
     groups=('base-devel')
     depends=('gcc-libs' 'libxcrypt')
 
-    _inst_bin sysusers
+    meson install -C build --destdir "$pkgdir" --no-rebuild --tags sysusers
 
-    mv -v build/sysusers.d/basic.conf "${pkgdir}"/usr/lib/sysusers.d
-    mv -v "$_pkgbase"/sysusers.d/README "${pkgdir}"/usr/lib/sysusers.d
+    mv -v  "${pkgdir}"/usr/bin/systemd-sysusers.standalone "${pkgdir}"/usr/bin/sysusers
+
+    _inst_man_utils sysusers
+    _inst_doc
 
     # pacman hooks
     make -C alpm-hooks DESTDIR="${pkgdir}" install_sysusers
@@ -235,11 +307,12 @@ package_etmpfiles() {
     groups=('base-devel')
     depends=('acl' 'libacl.so' 'libcap' 'libcap.so')
 
-    _inst_bin tmpfiles
+    meson install -C build --destdir "$pkgdir" --no-rebuild --tags tmpfiles
+
+    mv -v "${pkgdir}"/usr/bin/systemd-tmpfiles.standalone "${pkgdir}"/usr/bin/tmpfiles
 
-    install -d "${pkgdir}"/etc/tmpfiles.d
-    mv -v build/tmpfiles.d "${pkgdir}"/usr/lib/
-    mv -v "$_pkgbase"/tmpfiles.d/{{tmp,home,x11}.conf,README} "${pkgdir}"/usr/lib/tmpfiles.d
+    _inst_man_utils tmpfiles
+    _inst_doc
 
     # pacman hooks
     make -C alpm-hooks DESTDIR="${pkgdir}" install_tmpfiles
